#!/bin/sh
#
#This is for SLKE
#

FWPROD=7700DA4-SLKE-HD,7880ENC-MP2SD-IP
upgrade_status_flag=/tmp/upgrade_status
up_img=enc_img.tar

if [ -f enc_img.tgz ]; then
   rm -f enc_img.tgz
   mv enc_img1.tar $up_img
fi

#image file1 name
img1=uImage
#Dev to write this image to:
dev1=/dev/mtd2

#image file2 name
img2=enc_hd.ramdisk32m.gz
#Dev to write this image to:
dev2=/dev/mtd3

#Function to delete img files
rm_files() {
	rm -f $img1
	rm -f $img2
}

#Function to call if fails
fail() {
	rm_files
	echo "upgrade: $1"
	echo "102" > $upgrade_status_flag
	exit 1
}

boardfail() {
	rm_files
	echo "upgrade: $1"
	echo "101" > $upgrade_status_flag
	exit 1
}

#check product name
BRDPROD=7700DA4-SLKE-HD
#if [ -x /bin/fw_printenv ] ; then 
#   BRDPROD=`fw_printenv PROD | cut -d "=" -f2 | cut -d " " -f1`
#else
#   echo "fw_printenv is NOT exist, use default PROD name!!!!"
#   BRDPROD=7700DA4-SLKE-HD
#fi

if [ "$BRDPROD" = "" ]; then
boardfail "Please specify PROD in bootroom!"
fi

echo $BRDPROD:$FWPROD

supported=`echo $FWPROD | grep -c "$BRDPROD" `

if [ $supported -eq "0" ]; then
boardfail "error: This firware does NOT support  $BRDPROD !"
fi

#Write the image
echo "Do firmware updating ..."

#if [ -f /tmp/enc_img1.tgz ]; then
#  rm -f enc_img.tgz
#  mv enc_img1.tgz enc_img.tgz
#fi

#gunzip enc_img.tgz


tar xvf $up_img $img1
/ali/eraseall -q $dev1 || fail "error: flash_eraseall $dev1 failed."
/ali/nandwrite -p -q $dev1 $img1 || fail "error: nandwrite $dev1 $img1 failed."
rm -f $img1
	
tar xvf $up_img $img2	
/ali/eraseall -q $dev2 || fail "error: flash_eraseall $dev2 failed."
/ali/nandwrite -p -q $dev2 $img2 || fail "error: nandwrite $dev2 $img2 failed."
rm -f $img2

tar xvf $up_img vid_enc_cfg_720x480.txt


# Kam: To detect cross-platform and version upgrade for SLKE 
#aboutTo=`grep "platform" ./vid_enc_cfg_720x480.txt | cut -d "=" -f 2 | cut -d " " -f 2`
#aboutTo=`grep "platform" ./vid_enc_cfg_720x480.txt | cut -d "=" -f 2 | cut -d " " -f 2 | cut -d " " -f 1 | cut -d "^" -f 1 | cut -d "#" -f 1`
aboutTo=`grep "platform" ./vid_enc_cfg_720x480.txt | cut -d "=" -f 2 | cut -d " " -f 2 | cut -d " " -f 1 | cut -d "	" -f 1 `

#actual=`grep "platform" /mnt/flashdisk/vid_enc_cfg_720x480.txt | cut -d "=" -f 2 | cut -d " " -f 2`
#actual=`grep "platform"  /mnt/flashdisk/vid_enc_cfg_720x480.txt | cut -d "=" -f 2 | cut -d " " -f 2 | cut -d " " -f 1 | cut -d "^" -f 1 | cut -d "#" -f 1`
actual=`grep "platform"  /mnt/flashdisk/vid_enc_cfg_720x480.txt | cut -d "=" -f 2 | cut -d " " -f 2 | cut -d " " -f 1 | cut -d "	" -f 1`

aboutToFirmare=`grep "firmware_version" ./vid_enc_cfg_720x480.txt | cut -d "=" -f 2 | cut -d " " -f 2 | cut -d " " -f 1 | cut -d "^" -f 1`
actualFirmare=`grep "firmware_version"  /mnt/flashdisk/vid_enc_cfg_720x480.txt | cut -d "=" -f 2 | cut -d " " -f 2 | cut -d " " -f 1 | cut -d "^" -f 1`

echo $actual: $aboutToFirmare
echo $aboutTo: $actualFirmare

if [ "$actual" != "$aboutTo" ]; then
	echo "========== SLKE: Cross-Platform Upgrade...! (Default configuration will be restored) =========="
	cp ./vid_enc_cfg_720x480.txt /mnt/flashdisk/
	chmod a+rw /mnt/flashdisk/vid_enc_cfg_720x480.txt

elif [ "$aboutToFirmare" != "$actualFirmare" ]; then
	echo "========== SLKE: Version Upgrade...! (Current configuration will be restored) =========="
	sed "s/$actualFirmare/$aboutToFirmare/" /mnt/flashdisk/vid_enc_cfg_720x480.txt > /mnt/flashdisk/vid_enc_cfg_720x480.txt2
	rm /mnt/flashdisk/vid_enc_cfg_720x480.txt
	mv /mnt/flashdisk/vid_enc_cfg_720x480.txt2 /mnt/flashdisk/vid_enc_cfg_720x480.txt
	chmod 666 /mnt/flashdisk/vid_enc_cfg_720x480.txt

else
	echo "========== SLKE: Not a Cross-Platform Upgrade!  (Current configuration will be restored) =========="
fi
   
rm -f ./vid_enc_cfg_720x480.txt

rm_files	
echo "100" > $upgrade_status_flag
echo "wr_img.sh success"

exit 0
